#include <stdio.h>
#include <string.h>
#include <time.h>

int adj[256][256];
int edges[256][256];
int deg[256];
int n;

int comp_size[256];
int comp[256];
int c_count;
int comp_list[256][256];

int full[256];
int full_c;

int best[256][256], bcount, bsize[256];

clock_t timer;

int BFS(int node, int color) {
	int vis[256];
	int queue[256];
	int i, qe, qb, sz = 0;

	memset(vis, 0, sizeof(int)*256);
	qe = qb = 0;
	queue[qe++] = node;
	vis[node] = 1;
	while (qe > qb) {
		node = queue[qb++];
		comp_list[color][sz++] = node;
		comp[node] = color + 1;
		for (i = 0; i < deg[node]; i++)
			if (!vis[edges[node][i]]) {
				vis[edges[node][i]] = 1;
				queue[qe++] = edges[node][i];
			}
	}
	return sz;
}

void find_components() {
	int i;

	c_count = 0;
	for (i = 0; i < n; i++)
		if (!comp[i])
			comp_size[c_count++] = BFS(i, c_count);
}

int check_full(int x) {
	int i;
	
	for (i = 0; i < comp_size[x]; i++)
		if (deg[ comp_list[x][i] ] != comp_size[x] - 1)
			return 0;

	return 1;
}

void print_full() {
	int i, j;
	
	printf("%i\n", c_count);
	for (i = 0; i < c_count; i++) {
		printf("%i\n", comp_size[i]);
		for (j = 0; j < comp_size[i]; j++)
			printf("%s%i", (j ? " " : ""), comp_list[i][j] + 1);
		printf("\n");
	}
}

int vis[256];
void try_search(int bc, int x) {
	static int i, j;

	if (clock() - timer > 1.5*CLOCKS_PER_SEC)
		return;
		
	for (i = 0; i < comp_size[x]; i++)
		if (!vis[ comp_list[x][i] ]) {
			for (j = 0; j < bsize[bc]; j++)
				if (!adj[ comp_list[x][i] ][ best[x][j] ])
					break;
			if (j < bsize[bc])
				continue;
			best[bc][ bsize[bc]++ ] = comp_list[x][i];
			vis[ comp_list[x][i] ] = 1;
			try_search(bc, x);
			break;
		}
		
}
void match3(int x) {
	int i, j, k, l, m, p;
	int *list;

	list = comp_list[x];
	memset(vis, 0, sizeof(int)*256);
	for (i = 0; i < comp_size[x]; i++) {
		if (clock() - timer > 1.7*CLOCKS_PER_SEC)
			goto l3;
		if (!vis[ list[i] ])
			for (j = 0; j < comp_size[x]; j++)
				if (!vis[ list[j] ] && adj[ list[i] ][ list[j] ])
					for (k = 0; k < comp_size[x]; k++)
						if (!vis[ list[k] ] && adj[ list[j] ][ list[k] ] &&
							adj[ list[i] ][ list[k] ]) {
							vis[ list[i] ] = vis[ list[j] ] = vis[ list[k] ] = 1;
							best[bcount][ bsize[bcount]++ ] = list[i];
							best[bcount][ bsize[bcount]++ ] = list[j];
							best[bcount][ bsize[bcount]++ ] = list[k];

							for (l = 0; l < comp_size[x]; l++)
								if (!vis[ list[l] ] && adj[ list[j] ][ list[l] ] &&
									adj[ list[i] ][ list[l] ] &&
									adj[ list[l] ][ list[k] ]) {
								best[bcount][ bsize[bcount]++ ] = list[l];
								vis[ list[l] ] = 1;
								try_search(bcount, x);
								break;
							}

							bcount++;
							goto l1;
						}
l1:
	}
	for (i = 0; i < comp_size[x]; i++) {
		if (!vis[ list[i] ])
			for (j = 0; j < comp_size[x]; j++)
				if (!vis[ list[j] ] && adj[ list[i] ][ list[j] ]) {
					vis[ list[i] ] = vis[ list[j] ] = 1;
					best[bcount][ bsize[bcount]++ ] = list[i];
					best[bcount][ bsize[bcount]++ ] = list[j];
					bcount++;
					goto l2;
				}
l2:
	}
l3:
	for (i = 0; i < comp_size[x]; i++)
		if (!vis[ list[i] ]) {
			best[bcount][ bsize[bcount]++ ] = list[i];
			bcount++;
		}
}

/*
void match3(int x) {
//	int vis[256];
	int i, j, k, l, m, p;
	int *list;

	list = comp_list[x];
	memset(vis, 0, sizeof(int)*256);
	for (i = 0; i < comp_size[x]; i++) {
		if (clock() - timer > 1.6*CLOCKS_PER_SEC)
			goto l3;
		if (!vis[ list[i] ])
			for (j = 0; j < comp_size[x]; j++)
				if (!vis[ list[j] ] && adj[ list[i] ][ list[j] ])
					for (k = 0; k < comp_size[x]; k++)
						if (!vis[ list[k] ] && adj[ list[j] ][ list[k] ] &&
							adj[ list[i] ][ list[k] ]) {
							vis[ list[i] ] = vis[ list[j] ] = vis[ list[k] ] = 1;
							best[bcount][ bsize[bcount]++ ] = list[i];
							best[bcount][ bsize[bcount]++ ] = list[j];
							best[bcount][ bsize[bcount]++ ] = list[k];

							for (l = 0; l < comp_size[x]; l++)
								if (!vis[ list[l] ] && adj[ list[j] ][ list[l] ] &&
									adj[ list[i] ][ list[l] ] &&
									adj[ list[l] ][ list[k] ]) {
								best[bcount][ bsize[bcount]++ ] = list[l];
								vis[ list[l] ] = 1;
								for (m = 0; m < comp_size[x]; m++)
									if (!vis[ list[m] ] && adj[ list[j] ][ list[m] ] &&
										adj[ list[i] ][ list[m] ] &&
										adj[ list[l] ][ list[m] ] &&
										adj[ list[m] ][ list[k] ]) {
									best[bcount][ bsize[bcount]++ ] = list[m];
									vis[ list[m] ] = 1;
						for (p = 0; p < comp_size[x]; p++)
							if (!vis[ list[p] ] &&
								adj[ list[j] ][ list[p] ] &&
								adj[ list[i] ][ list[p] ] &&
								adj[ list[m] ][ list[p] ] &&
								adj[ list[l] ][ list[p] ] &&
								adj[ list[p] ][ list[k] ]) {
							best[bcount][ bsize[bcount]++ ] = list[p];
							vis[ list[p] ] = 1;
							break;
						}
									break;
								}
								break;
							}

							bcount++;
							goto l1;
						}
l1:
	}
	for (i = 0; i < comp_size[x]; i++) {
		if (!vis[ list[i] ])
			for (j = 0; j < comp_size[x]; j++)
				if (!vis[ list[j] ] && adj[ list[i] ][ list[j] ]) {
					vis[ list[i] ] = vis[ list[j] ] = 1;
					best[bcount][ bsize[bcount]++ ] = list[i];
					best[bcount][ bsize[bcount]++ ] = list[j];
					bcount++;
					goto l2;
				}
l2:
	}
l3:
	for (i = 0; i < comp_size[x]; i++)
		if (!vis[ list[i] ]) {
			best[bcount][ bsize[bcount]++ ] = list[i];
			bcount++;
		}
}
*/

void print_out() {
	int i, j;

	printf("%i\n", bcount + full_c);
	for (i = 0; i < c_count; i++)
		if (full[i]) {
			printf("%i\n", comp_size[i]);
			for (j = 0; j < comp_size[i]; j++)
				printf("%s%i", (j ? " " : ""), comp_list[i][j] + 1);
			printf("\n");
		}
	for (i = 0; i < bcount; i++) {
		printf("%i\n", bsize[i]);
		for (j = 0; j < bsize[i]; j++)
			printf("%s%i", (j ? " " : ""), best[i][j] + 1);
		printf("\n");
	}
}

int main() {
	char line[256];
	int i, j, c;
	
	timer = clock();
	scanf("%i", &n);
	for (i = 1; i < n; i++) {
		scanf("%s", line);
		for (j = 0; j < i; j++)
			if (line[j] == '1') {
				adj[i][j] = adj[j][i] = 1;
				edges[i][deg[i]++] = j;
				edges[j][deg[j]++] = i;
			}
	}

	bcount = 0;
	find_components();
	full_c = 0;
	for (i = 0; i < c_count; i++) {
		full[i] = check_full(i);
		if (full[i])
			full_c++;
	}
	if (full_c == c_count) {
		print_full();
		return 0;
	}

	for (i = 0; i < c_count; i++)
		if (!full[i])
			match3(i);

	print_out();
	
	return 0;
}

