#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int comb[128];
int ptr = 0;
int f[128][128];
int S, k;

int fcmp(const void *e1, const void *e2) {
	return *(int *)e2 - *(int *)e1;
}

void calc() {
	int s, n, i;

	f[0][0] = 1;
	for (n = 1; n <= S; n++)
		f[0][n] = 0;
		
	for (s = 1; s <= S; s++)
		for (n = 1; n <= s; n++) {
			f[s][n] = 0;
			for (i = 0; i <= n; i++)
				f[s][n] += f[s - n][i];
		}
}

void parse() {
	char line[1024];
	char *temp;
	int x;

	fgets(line, 1024, stdin);
	
	temp = line; S = 0; ptr = 0;
	while (1) {
		while (temp[0] && (temp[0] < '0' || temp[0] > '9'))
			temp++;
		if (!temp[0])
			break;
		x = 0;
		while (temp[0] >= '0' && temp[0] <= '9') {
			x = 10*x + temp[0] - '0';
			temp++;
		}
		comb[ptr++] = x;
		S += x;
	}
}

int code() {
	int i, j, s = S;
	int c = 0;
	
	for (i = 0; i < ptr; i++) {
		for (j = (i ? comb[i - 1] : s); j > comb[i]; j--)
			c += f[s][j];
		s -= comb[i];
	}
	return c;
}

int decode(int c) {
	int s = S, t;
	int i;

	ptr = 0; i = s;
	while (s) {
		t = 0;
		while (1) {
			if (t + f[s][i] > c)
				break;
			t += f[s][i];
			i--;
			if (!i)
				return c;
		}
		comb[ptr++] = i;
		s -= i;
		c -= t;
		if (i > s)
			i = s;
	}
	return -1;
}

int main() {
	int c, i;

	parse();
	scanf("%i", &k);
	calc();
	qsort(comb, ptr, sizeof(int), fcmp);
	c = code();
//	printf("%i\n", c);
	c += k;
	i = decode(c);
	if (i == -1) {
		for (i = 0; i < ptr; i++)
			printf("%s%i", (i ? " " : ""), comb[i]);
		printf("\n");
	}
	else {
		for (i = 0; i < S; i++)
			comb[i] = 1;
		ptr = S;
		i = code();
		printf("%i\n", i - c + k);
	}
	
	return 0;
}

